

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
 
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.epsilon.egl.EglFileGeneratingTemplateFactory; 
import org.eclipse.epsilon.egl.EglTemplateFactoryModuleAdapter;
import org.eclipse.epsilon.eol.IEolExecutableModule;
import org.eclipse.epsilon.eol.models.IModel;
import org.eclipse.uml2.uml.UMLPackage;  

public class EglStandaloneExample extends EpsilonStandaloneExample {
	
	public static void main(String[] args) throws Exception {
		new EglStandaloneExample().execute();
	}
	
	@Override
	public IEolExecutableModule createModule() {
		return new EglTemplateFactoryModuleAdapter(new EglFileGeneratingTemplateFactory());
	}

	@Override
	public List<IModel> getModels() throws Exception {
		List<IModel> models = new ArrayList<IModel>(); 
		EPackage.Registry.INSTANCE.put(UMLPackage.eINSTANCE.getNsURI(), UMLPackage.eINSTANCE);
		// SELECT THE UML FILE
		String example=""; 
		File fileToSave = null;
		JFrame parentFrame = new JFrame();		 
		JFileChooser fileChooser = new JFileChooser();
		boolean compatibleFile=false;
		while (!compatibleFile){
			fileChooser.setDialogTitle("Select the UML model file:"); 		 
			int userSelection = fileChooser.showSaveDialog(parentFrame);		 
			if (userSelection == JFileChooser.APPROVE_OPTION) {
				fileToSave = fileChooser.getSelectedFile();
				if (fileToSave.getName().endsWith(".uml")) {
					example=fileToSave.getAbsolutePath();
					compatibleFile=true;
				}		      
			}
		} 
		
		models.add(createUmlModelByURI("M", example, UMLPackage.eNS_URI, true, true));  
		return models;
	}

	@Override
	public String getSource() throws Exception {
		return "ProjectCreation.egl";
	}

	@Override
	public void postProcess() { 
		System.out.println(result);
	}

}
